package org.aspectjml.lang.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.Target;
import java.lang.annotation.ElementType;
import java.lang.annotation.Repeatable;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
@Documented
public @interface DeclareError {
	
	/**
     * The pointcut expression where to bind the error
     */
    String value() default "";
    
    /**
     * The pointcut expression where to bind the error, overrides "value" when specified
     */
    String pointcut() default "";

}
	